
#!/usr/bin/env python

import glob, os
import sys
import subprocess
import csv
import io
from shutil import copyfile
import fnmatch

#Jen test zda to bezi
#f = open('/tmp/test.txt', 'w')
#f.write('This is a test\n')
#f.close()

#Pridani cest k qgis, to nefungovalo, ale pres bat ano
#sys.path.append("C:\\Program Files\\QGIS 2.16.1\\bin")
#sys.path.append("C:\\Program Files\\QGIS 2.16.1\\apps\\Python27\\Scripts")
#sys.path.append("C:\\Windows\\system32")
#sys.path.append("C:\\Windows")
#sys.path.append("C:\\Windows\\WBem")
#print sys.path

#Zkusime jeste linux
sys.path.append("/usr/local/sbin")
sys.path.append("/usr/local/bin")
sys.path.append("/usr/sbin")
sys.path.append("/usr/bin")
sys.path.append("/sbin")
sys.path.append("/bin")
sys.path.append("/usr/games")
sys.path.append("/usr/local/games")

# path to the GRASS GIS launch script
# MS Windows
# grass7bin_win = r'C:\OSGeo4W\bin\grass70svn.bat'
# uncomment when using standalone WinGRASS installer
grass7bin_win = r'C:\OSGeo4W64\bin\grass72.bat'
# Linux
grass7bin_lin = 'grass72'
# Mac OS X
# this is TODO
grass7bin_mac = '/Applications/GRASS/GRASS-7.0.app/'

# DATA
# define GRASS DATABASE
# add your path to grassdata (GRASS GIS database) directory
DATAPATH=str(sys.argv[1])
PLUGINPATH=str(sys.argv[2]) 
gisdb = DATAPATH + "/grassdata"
# the following path is the default path on MS Windows
# gisdb = os.path.join(os.path.expanduser("~"), "Documents/grassdata")

# specify (existing) location and mapset
location = "wgs84"
mapset   = "PERMANENT"


########### SOFTWARE
if sys.platform.startswith('linux'):
    # we assume that the GRASS GIS start script is available and in the PATH
    # query GRASS 7 itself for its GISBASE
    grass7bin = grass7bin_lin
elif sys.platform.startswith('win'):
    grass7bin = grass7bin_win
else:
    raise OSError('Platform not configured.')

# query GRASS 7 itself for its GISBASE
startcmd = [grass7bin, '--config', 'path']

p = subprocess.Popen(startcmd, shell=False,
                     stdout=subprocess.PIPE, stderr=subprocess.PIPE)
out, err = p.communicate()
if p.returncode != 0:
    print >>sys.stderr, "ERROR: Cannot find GRASS GIS 7 start script (%s)" % startcmd
    sys.exit(-1)
gisbase = out.strip('\n\r')

# Set GISBASE environment variable
os.environ['GISBASE'] = gisbase
# the following not needed with trunk
os.environ['PATH'] += os.pathsep + os.path.join(gisbase, 'extrabin')
# add path to GRASS addons
home = os.path.expanduser("~")
os.environ['PATH'] += os.pathsep + os.path.join(home, '.grass7', 'addons', 'scripts')

# define GRASS-Python environment
gpydir = os.path.join(gisbase, "etc", "python")
sys.path.append(gpydir)

########### DATA
# Set GISDBASE environment variable
os.environ['GISDBASE'] = gisdb
 
# import GRASS Python bindings (see also pygrass)
import grass.script as gscript
import grass.script.setup as gsetup
#from grass.pygrass.modules.shortcuts import raster as r
 
###########
# launch session
gsetup.init(gisbase,
            gisdb, location, mapset)
 
#gscript.message('Current GRASS GIS 7 environment:')
#print gscript.gisenv()

SECTOR=str(sys.argv[3])
DATEFROM=str(sys.argv[4])
DATETO=str(sys.argv[5])
PATH=str(sys.argv[6])

#Creates output directory
if not os.path.exists(DATAPATH + '/search/gpx/' + SECTOR):
    os.makedirs(DATAPATH + '/search/gpx/' + SECTOR)

#Removes previously created output in WKT
if os.path.isfile(DATAPATH + '/search/temp/out.csv'):
    os.remove(DATAPATH + '/search/temp/out.csv')

#Path to GPX is send as parameter
for root, dirnames, filenames in os.walk(DATAPATH + '/search/temp'):
    for f in fnmatch.filter(filenames, '*.gpx'):
        print f
        if os.path.isfile(os.path.join(root, f.decode('utf8'))):
            #Copy original files
            copyfile(os.path.join(root, f.decode('utf8')), DATAPATH + '/search/gpx/' + SECTOR + '/' + os.path.basename(f))
            #Extracts from file records in time extent
            if sys.platform.startswith('win'):
                p = subprocess.Popen((PLUGINPATH + '/xslt/run_xslt.bat', PLUGINPATH, os.path.join(root, f.decode('utf8')), DATAPATH + '/search/temp/out.csv', DATEFROM, DATETO))
                p.wait()
            else:
                p = subprocess.Popen(('bash', PLUGINPATH + '/xslt/run_xslt.sh', PLUGINPATH,
                                      os.path.join(root, f.decode('utf8')), DATAPATH + '/search/temp/out.csv', DATEFROM,
                                      DATETO))
                p.wait()

#Reads GML header
header = io.open(PLUGINPATH + '/xslt/gml_header.gml', encoding='utf-8', mode='r').read()
#Writes GML header
f = io.open(DATAPATH + '/search/temp/out_polyline.gml', encoding='utf-8', mode='w')
f.write(header)
f.write(u'<gml:featureMember>\n')
f.write(u'<ogr:sample fid="sample.0">\n')
f.write(u'<ogr:geometryProperty><gml:LineString><gml:coordinates>\n')
        
#Reads all selected records and writes them as one linestring to GML
with open(DATAPATH + '/search/temp/out.csv') as csvDataFile:
    csvReader = csv.reader(csvDataFile, delimiter=';')
    for row in csvReader:
        ##print(row)    
        f.write(row[1] + u',' + row[0] + u' ')

f.write(u'</gml:coordinates></gml:LineString></ogr:geometryProperty>\n')
f.write(u'<ogr:cat>13</ogr:cat>\n')
f.write(u'</ogr:sample>\n')
f.write(u'</gml:featureMember>\n')
f.write(u'</ogr:FeatureCollection>')
f.close()

#TODO - make it faster without GRASSS
#Imports GML to GRASS
print gscript.read_command('v.in.ogr', input=DATAPATH + '/search/temp/out_polyline.gml', output='out_polyline', flags='o', overwrite=True)
#Exports SHP from imported GML
print gscript.read_command('v.out.ogr', input='out_polyline', output=DATAPATH + '/search/shp/' + SECTOR + '.shp', overwrite=True)
